/* *****************************************************************************
 * Copyright (c) 2013 Benjamin Krill <benjamin@krll.de>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * ****************************************************************************/
#ifndef _STRM_H
#define _STRM_H

#include <stdint.h>
#include <usb.h>

#define STRM_TYPE_DDR2 0x1
#define STRM_DDR2_WRITE_HDR_INIT(addr) \
	(uint32_t)(0x80000000 | (addr & 0x0fffffff))
#define STRM_DDR2_READ_HDR_INIT(addr) \
	(uint32_t)(~(0x1 << 31) & (addr & 0x0fffffff))

#define STRM_TYPE_REGFILE 0x2
#define STRM_REGFILE_WRITE_HDR_INIT(addr) \
	(uint32_t)(0x80000000 | (addr & 0x0fffffff))
#define STRM_REGFILE_READ_HDR_INIT(addr) \
	(uint32_t)(~(0x1 << 31) & (addr & 0x0fffffff))

/* prototypes */
usb_dev_handle *strm_init(int vendor, int product);
int strm_fini(void);

#endif /* _STRM_H */
